summaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
Diffstat (limited to 'tools')
-rwxr-xr-xtools/changelog.sh42
-rw-r--r--tools/check_for_upgrade.sh86
-rwxr-xr-xtools/install.sh188
-rwxr-xr-xtools/upgrade.sh50
4 files changed, 262 insertions, 104 deletions
diff --git a/tools/changelog.sh b/tools/changelog.sh
index 664f34608..6489a3cb2 100755
--- a/tools/changelog.sh
+++ b/tools/changelog.sh
@@ -23,8 +23,7 @@ TYPES=(
test "Testing"
)
-#* Types that will be displayed in their own section,
-#* in the order specified here.
+#* Types that will be displayed in their own section, in the order specified here.
local -a MAIN_TYPES
MAIN_TYPES=(feat fix perf docs)
@@ -34,7 +33,8 @@ OTHER_TYPES=(refactor style other)
#* Commit types that don't appear in $MAIN_TYPES nor $OTHER_TYPES
#* will not be displayed and will simply be ignored.
-
+local -a IGNORED_TYPES
+IGNORED_TYPES=(${${${(@k)TYPES}:|MAIN_TYPES}:|OTHER_TYPES})
############################
# COMMIT PARSING UTILITIES #
@@ -139,7 +139,7 @@ function parse-commit {
# [BREAKING CHANGE: warning]
# commits holds the commit type
- commits[$hash]="$(commit:type "$subject")"
+ types[$hash]="$(commit:type "$subject")"
# scopes holds the commit scope
scopes[$hash]="$(commit:scope "$subject")"
# subjects holds the commit subject
@@ -164,26 +164,32 @@ function parse-commit {
function display-release {
# This function uses the following globals: output, version,
- # commits (A), subjects (A), scopes (A), breaking (A) and reverts (A).
+ # types (A), subjects (A), scopes (A), breaking (A) and reverts (A).
#
# - output is the output format to use when formatting (raw|text|md)
# - version is the version in which the commits are made
- # - commits, subjects, scopes, breaking, and reverts are associative arrays
+ # - types, subjects, scopes, breaking, and reverts are associative arrays
# with commit hashes as keys
# Remove commits that were reverted
local hash rhash
for hash rhash in ${(kv)reverts}; do
- if (( ${+commits[$rhash]} )); then
+ if (( ${+types[$rhash]} )); then
# Remove revert commit
- unset "commits[$hash]" "subjects[$hash]" "scopes[$hash]" "breaking[$hash]"
+ unset "types[$hash]" "subjects[$hash]" "scopes[$hash]" "breaking[$hash]"
# Remove reverted commit
- unset "commits[$rhash]" "subjects[$rhash]" "scopes[$rhash]" "breaking[$rhash]"
+ unset "types[$rhash]" "subjects[$rhash]" "scopes[$rhash]" "breaking[$rhash]"
fi
done
+ # Remove commits from ignored types unless it has breaking change information
+ for hash in ${(k)types[(R)${(j:|:)IGNORED_TYPES}]}; do
+ (( ! ${+breaking[$hash]} )) || continue
+ unset "types[$hash]" "subjects[$hash]" "scopes[$hash]"
+ done
+
# If no commits left skip displaying the release
- if (( $#commits == 0 )); then
+ if (( $#types == 0 )); then
return
fi
@@ -313,7 +319,7 @@ function display-release {
local hash type="$1"
local -a hashes
- hashes=(${(k)commits[(R)$type]})
+ hashes=(${(k)types[(R)$type]})
# If no commits found of type $type, go to next type
(( $#hashes != 0 )) || return 0
@@ -330,7 +336,7 @@ function display-release {
# Commits made under types considered other changes
local -A changes
- changes=(${(kv)commits[(R)${(j:|:)OTHER_TYPES}]})
+ changes=(${(kv)types[(R)${(j:|:)OTHER_TYPES}]})
# If no commits found under "other" types, don't display anything
(( $#changes != 0 )) || return 0
@@ -388,19 +394,19 @@ function main {
fi
# Commit classification arrays
- local -A commits subjects scopes breaking reverts
+ local -A types subjects scopes breaking reverts
local truncate=0 read_commits=0
local version tag
local hash refs subject body
# Get the first version name:
# 1) try tag-like version, or
- # 2) try name-rev, or
- # 3) try branch name, or
+ # 2) try branch name, or
+ # 3) try name-rev, or
# 4) try short hash
version=$(command git describe --tags $until 2>/dev/null) \
- || version=$(command git name-rev --no-undefined --name-only --exclude="remotes/*" $until 2>/dev/null) \
|| version=$(command git symbolic-ref --quiet --short $until 2>/dev/null) \
+ || version=$(command git name-rev --no-undefined --name-only --exclude="remotes/*" $until 2>/dev/null) \
|| version=$(command git rev-parse --short $until 2>/dev/null)
# Get commit list from $until commit until $since commit, or until root commit if $since is unset
@@ -414,7 +420,7 @@ function main {
# --first-parent: commits from merged branches are omitted
local SEP="0mZmAgIcSeP"
local -a raw_commits
- raw_commits=(${(0)"$(command git log -z \
+ raw_commits=(${(0)"$(command git -c log.showSignature=false log -z \
--format="%h${SEP}%D${SEP}%s${SEP}%b" --abbrev=7 \
--no-merges --first-parent $range)"})
@@ -441,7 +447,7 @@ function main {
# Output previous release
display-release
# Reinitialize commit storage
- commits=()
+ types=()
subjects=()
scopes=()
breaking=()
diff --git a/tools/check_for_upgrade.sh b/tools/check_for_upgrade.sh
index 293f48edf..a36aecb84 100644
--- a/tools/check_for_upgrade.sh
+++ b/tools/check_for_upgrade.sh
@@ -10,11 +10,13 @@ fi
# - auto: the update is performed automatically when it's time
# - reminder: a reminder is shown to the user when it's time to update
# - disabled: automatic update is turned off
-zstyle -s ':omz:update' mode update_mode || update_mode=prompt
+zstyle -s ':omz:update' mode update_mode || {
+ update_mode=prompt
-# Support old-style settings
-[[ "$DISABLE_UPDATE_PROMPT" != true ]] || update_mode=auto
-[[ "$DISABLE_AUTO_UPDATE" != true ]] || update_mode=disabled
+ # If the mode zstyle setting is not set, support old-style settings
+ [[ "$DISABLE_UPDATE_PROMPT" != true ]] || update_mode=auto
+ [[ "$DISABLE_AUTO_UPDATE" != true ]] || update_mode=disabled
+}
# Cancel update if:
# - the automatic update is disabled.
@@ -34,11 +36,11 @@ function current_epoch() {
function is_update_available() {
local branch
- branch=${"$(cd "$ZSH"; git config --local oh-my-zsh.branch)":-master}
+ branch=${"$(cd -q "$ZSH"; git config --local oh-my-zsh.branch)":-master}
local remote remote_url remote_repo
- remote=${"$(cd "$ZSH"; git config --local oh-my-zsh.remote)":-origin}
- remote_url=$(cd "$ZSH"; git config remote.$remote.url)
+ remote=${"$(cd -q "$ZSH"; git config --local oh-my-zsh.remote)":-origin}
+ remote_url=$(cd -q "$ZSH"; git config remote.$remote.url)
local repo
case "$remote_url" in
@@ -56,7 +58,7 @@ function is_update_available() {
# Get local HEAD. If this fails assume there are updates
local local_head
- local_head=$(cd "$ZSH"; git rev-parse $branch 2>/dev/null) || return 0
+ local_head=$(cd -q "$ZSH"; git rev-parse $branch 2>/dev/null) || return 0
# Get remote HEAD. If no suitable command is found assume there are updates
# On any other error, skip the update (connection may be down)
@@ -87,6 +89,31 @@ function update_ohmyzsh() {
fi
}
+function has_typed_input() {
+ # Created by Philippe Troin <phil@fifi.org>
+ # https://zsh.org/mla/users/2022/msg00062.html
+ emulate -L zsh
+ zmodload zsh/zselect
+
+ # Back up stty settings prior to disabling canonical mode
+ # Consider that no input can be typed if stty fails
+ # (this might happen if stdin is not a terminal)
+ local termios
+ termios=$(stty --save 2>/dev/null) || return 1
+ {
+ # Disable canonical mode so that typed input counts
+ # regardless of whether Enter was pressed
+ stty -icanon
+
+ # Poll stdin (fd 0) for data ready to be read
+ zselect -t 0 -r 0
+ return $?
+ } always {
+ # Restore stty settings
+ stty $termios
+ }
+}
+
() {
emulate -L zsh
@@ -134,7 +161,7 @@ function update_ohmyzsh() {
fi
# Test if Oh My Zsh directory is a git repository
- if ! (cd "$ZSH" && LANG= git rev-parse &>/dev/null); then
+ if ! (cd -q "$ZSH" && LANG= git rev-parse &>/dev/null); then
echo >&2 "[oh-my-zsh] Can't update: not a git repository."
return
fi
@@ -144,26 +171,35 @@ function update_ohmyzsh() {
return
fi
- # Ask for confirmation before updating unless in auto mode
+ # Don't ask for confirmation before updating if in auto mode
if [[ "$update_mode" = auto ]]; then
update_ohmyzsh
- elif [[ "$update_mode" = reminder ]]; then
+ return $?
+ fi
+
+ # If in reminder mode show reminder and exit
+ if [[ "$update_mode" = reminder ]]; then
echo "[oh-my-zsh] It's time to update! You can do that by running \`omz update\`"
- else
- # input sink to swallow all characters typed before the prompt
- # and add a newline if there wasn't one after characters typed
- while read -t -k 1 option; do true; done
- [[ "$option" != ($'\n'|"") ]] && echo
-
- echo -n "[oh-my-zsh] Would you like to update? [Y/n] "
- read -r -k 1 option
- [[ "$option" != $'\n' ]] && echo
- case "$option" in
- [yY$'\n']) update_ohmyzsh ;;
- [nN]) update_last_updated_file ;&
- *) echo "[oh-my-zsh] You can update manually by running \`omz update\`" ;;
- esac
+ return 0
fi
+
+ # If user has typed input, show reminder and exit
+ if has_typed_input; then
+ echo
+ echo "[oh-my-zsh] It's time to update! You can do that by running \`omz update\`"
+ return 0
+ fi
+
+ # Ask for confirmation and only update on 'y', 'Y' or Enter
+ # Otherwise just show a reminder for how to update
+ echo -n "[oh-my-zsh] Would you like to update? [Y/n] "
+ read -r -k 1 option
+ [[ "$option" = $'\n' ]] || echo
+ case "$option" in
+ [yY$'\n']) update_ohmyzsh ;;
+ [nN]) update_last_updated_file ;&
+ *) echo "[oh-my-zsh] You can update manually by running \`omz update\`" ;;
+ esac
}
unset update_mode
diff --git a/tools/install.sh b/tools/install.sh
index 731d89a29..e64e39063 100755
--- a/tools/install.sh
+++ b/tools/install.sh
@@ -37,6 +37,13 @@
#
set -e
+# Make sure important variables exist if not already defined
+#
+# $USER is defined by login(1) which is not always executed (e.g. containers)
+# POSIX: https://pubs.opengroup.org/onlinepubs/009695299/utilities/id.html
+USER=${USER:-$(id -u -n)}
+
+
# Track if $ZSH was provided
custom_zsh=${ZSH:+yes}
@@ -56,6 +63,30 @@ command_exists() {
command -v "$@" >/dev/null 2>&1
}
+user_can_sudo() {
+ # Check if sudo is installed
+ command_exists sudo || return 1
+ # The following command has 3 parts:
+ #
+ # 1. Run `sudo` with `-v`. Does the following:
+ # • with privilege: asks for a password immediately.
+ # • without privilege: exits with error code 1 and prints the message:
+ # Sorry, user <username> may not run sudo on <hostname>
+ #
+ # 2. Pass `-n` to `sudo` to tell it to not ask for a password. If the
+ # password is not required, the command will finish with exit code 0.
+ # If one is required, sudo will exit with error code 1 and print the
+ # message:
+ # sudo: a password is required
+ #
+ # 3. Check for the words "may not run sudo" in the output to really tell
+ # whether the user has privileges or not. For that we have to make sure
+ # to run `sudo` in the default locale (with `LANG=`) so that the message
+ # stays consistent regardless of the user's locale.
+ #
+ ! LANG= sudo -n -v 2>&1 | grep -q "may not run sudo"
+}
+
# The [ -t 1 ] check only works when the function is not called from
# a subshell (like in `$(...)` or `(...)`, so this hack redefines the
# function at the top level to always return false when stdout is not
@@ -127,6 +158,24 @@ supports_hyperlinks() {
return 1
}
+# Adapted from code and information by Anton Kochkov (@XVilka)
+# Source: https://gist.github.com/XVilka/8346728
+supports_truecolor() {
+ case "$COLORTERM" in
+ truecolor|24bit) return 0 ;;
+ esac
+
+ case "$TERM" in
+ iterm |\
+ tmux-truecolor |\
+ linux-truecolor |\
+ xterm-truecolor |\
+ screen-truecolor) return 0 ;;
+ esac
+
+ return 1
+}
+
fmt_link() {
# $1: text, $2: url, $3: fallback mode
if supports_hyperlinks; then
@@ -150,13 +199,34 @@ fmt_code() {
}
fmt_error() {
- printf '%sError: %s%s\n' "$BOLD$RED" "$*" "$RESET" >&2
+ printf '%sError: %s%s\n' "${FMT_BOLD}${FMT_RED}" "$*" "$FMT_RESET" >&2
}
setup_color() {
# Only use colors if connected to a terminal
- if is_tty; then
- RAINBOW="
+ if ! is_tty; then
+ FMT_RAINBOW=""
+ FMT_RED=""
+ FMT_GREEN=""
+ FMT_YELLOW=""
+ FMT_BLUE=""
+ FMT_BOLD=""
+ FMT_RESET=""
+ return
+ fi
+
+ if supports_truecolor; then
+ FMT_RAINBOW="
+ $(printf '\033[38;2;255;0;0m')
+ $(printf '\033[38;2;255;97;0m')
+ $(printf '\033[38;2;247;255;0m')
+ $(printf '\033[38;2;0;255;30m')
+ $(printf '\033[38;2;77;0;255m')
+ $(printf '\033[38;2;168;0;255m')
+ $(printf '\033[38;2;245;0;172m')
+ "
+ else
+ FMT_RAINBOW="
$(printf '\033[38;5;196m')
$(printf '\033[38;5;202m')
$(printf '\033[38;5;226m')
@@ -165,21 +235,14 @@ setup_color() {
$(printf '\033[38;5;093m')
$(printf '\033[38;5;163m')
"
- RED=$(printf '\033[31m')
- GREEN=$(printf '\033[32m')
- YELLOW=$(printf '\033[33m')
- BLUE=$(printf '\033[34m')
- BOLD=$(printf '\033[1m')
- RESET=$(printf '\033[m')
- else
- RAINBOW=""
- RED=""
- GREEN=""
- YELLOW=""
- BLUE=""
- BOLD=""
- RESET=""
fi
+
+ FMT_RED=$(printf '\033[31m')
+ FMT_GREEN=$(printf '\033[32m')
+ FMT_YELLOW=$(printf '\033[33m')
+ FMT_BLUE=$(printf '\033[34m')
+ FMT_BOLD=$(printf '\033[1m')
+ FMT_RESET=$(printf '\033[0m')
}
setup_ohmyzsh() {
@@ -190,7 +253,7 @@ setup_ohmyzsh() {
# precedence over umasks except for filesystems mounted with option "noacl".
umask g-w,o-w
- echo "${BLUE}Cloning Oh My Zsh...${RESET}"
+ echo "${FMT_BLUE}Cloning Oh My Zsh...${FMT_RESET}"
command_exists git || {
fmt_error "git is not installed"
@@ -204,13 +267,19 @@ setup_ohmyzsh() {
exit 1
fi
- git clone -c core.eol=lf -c core.autocrlf=false \
- -c fsck.zeroPaddedFilemode=ignore \
- -c fetch.fsck.zeroPaddedFilemode=ignore \
- -c receive.fsck.zeroPaddedFilemode=ignore \
- -c oh-my-zsh.remote=origin \
- -c oh-my-zsh.branch="$BRANCH" \
- --depth=1 --branch "$BRANCH" "$REMOTE" "$ZSH" || {
+ # Manual clone with git config options to support git < v1.7.2
+ git init "$ZSH" && cd "$ZSH" \
+ && git config core.eol lf \
+ && git config core.autocrlf false \
+ && git config fsck.zeroPaddedFilemode ignore \
+ && git config fetch.fsck.zeroPaddedFilemode ignore \
+ && git config receive.fsck.zeroPaddedFilemode ignore \
+ && git config oh-my-zsh.remote origin \
+ && git config oh-my-zsh.branch "$BRANCH" \
+ && git remote add origin "$REMOTE" \
+ && git fetch --depth=1 origin \
+ && git checkout -b "$BRANCH" "origin/$BRANCH" || {
+ rm -rf "$ZSH"
fmt_error "git clone of oh-my-zsh repo failed"
exit 1
}
@@ -222,14 +291,14 @@ setup_zshrc() {
# Keep most recent old .zshrc at .zshrc.pre-oh-my-zsh, and older ones
# with datestamp of installation that moved them aside, so we never actually
# destroy a user's original zshrc
- echo "${BLUE}Looking for an existing zsh config...${RESET}"
+ echo "${FMT_BLUE}Looking for an existing zsh config...${FMT_RESET}"
# Must use this exact name so uninstall.sh can find it
OLD_ZSHRC=~/.zshrc.pre-oh-my-zsh
if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
# Skip this if the user doesn't want to replace an existing .zshrc
if [ "$KEEP_ZSHRC" = yes ]; then
- echo "${YELLOW}Found ~/.zshrc.${RESET} ${GREEN}Keeping...${RESET}"
+ echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Keeping...${FMT_RESET}"
return
fi
if [ -e "$OLD_ZSHRC" ]; then
@@ -241,14 +310,14 @@ setup_zshrc() {
fi
mv "$OLD_ZSHRC" "${OLD_OLD_ZSHRC}"
- echo "${YELLOW}Found old ~/.zshrc.pre-oh-my-zsh." \
- "${GREEN}Backing up to ${OLD_OLD_ZSHRC}${RESET}"
+ echo "${FMT_YELLOW}Found old ~/.zshrc.pre-oh-my-zsh." \
+ "${FMT_GREEN}Backing up to ${OLD_OLD_ZSHRC}${FMT_RESET}"
fi
- echo "${YELLOW}Found ~/.zshrc.${RESET} ${GREEN}Backing up to ${OLD_ZSHRC}${RESET}"
+ echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Backing up to ${OLD_ZSHRC}${FMT_RESET}"
mv ~/.zshrc "$OLD_ZSHRC"
fi
- echo "${GREEN}Using the Oh My Zsh template file and adding it to ~/.zshrc.${RESET}"
+ echo "${FMT_GREEN}Using the Oh My Zsh template file and adding it to ~/.zshrc.${FMT_RESET}"
# Replace $HOME path with '$HOME' in $ZSH variable in .zshrc file
omz=$(echo "$ZSH" | sed "s|^$HOME/|\$HOME/|")
@@ -273,19 +342,19 @@ setup_shell() {
if ! command_exists chsh; then
cat <<EOF
I can't change your shell automatically because this system does not have chsh.
-${BLUE}Please manually change your default shell to zsh${RESET}
+${FMT_BLUE}Please manually change your default shell to zsh${FMT_RESET}
EOF
return
fi
- echo "${BLUE}Time to change your default shell to zsh:${RESET}"
+ echo "${FMT_BLUE}Time to change your default shell to zsh:${FMT_RESET}"
# Prompt for user choice on changing the default login shell
printf '%sDo you want to change your default shell to zsh? [Y/n]%s ' \
- "$YELLOW" "$RESET"
+ "$FMT_YELLOW" "$FMT_RESET"
read -r opt
case $opt in
- y*|Y*|"") echo "Changing the shell..." ;;
+ y*|Y*|"") ;;
n*|N*) echo "Shell change skipped."; return ;;
*) echo "Invalid choice. Shell change skipped."; return ;;
esac
@@ -323,38 +392,55 @@ EOF
if [ -n "$SHELL" ]; then
echo "$SHELL" > ~/.shell.pre-oh-my-zsh
else
- grep "^$USERNAME:" /etc/passwd | awk -F: '{print $7}' > ~/.shell.pre-oh-my-zsh
+ grep "^$USER:" /etc/passwd | awk -F: '{print $7}' > ~/.shell.pre-oh-my-zsh
+ fi
+
+ echo "Changing your shell to $zsh..."
+
+ # Check if user has sudo privileges to run `chsh` with or without `sudo`
+ #
+ # This allows the call to succeed without password on systems where the
+ # user does not have a password but does have sudo privileges, like in
+ # Google Cloud Shell.
+ #
+ # On systems that don't have a user with passwordless sudo, the user will
+ # be prompted for the password either way, so this shouldn't cause any issues.
+ #
+ if user_can_sudo; then
+ sudo -k chsh -s "$zsh" "$USER" # -k forces the password prompt
+ else
+ chsh -s "$zsh" "$USER" # run chsh normally
fi
- # Actually change the default shell to zsh
- if ! chsh -s "$zsh"; then
+ # Check if the shell change was successful
+ if [ $? -ne 0 ]; then
fmt_error "chsh command unsuccessful. Change your default shell manually."
else
export SHELL="$zsh"
- echo "${GREEN}Shell successfully changed to '$zsh'.${RESET}"
+ echo "${FMT_GREEN}Shell successfully changed to '$zsh'.${FMT_RESET}"
fi
echo
}
-# shellcheck disable=SC2183 # printf string has more %s than arguments ($RAINBOW expands to multiple arguments)
+# shellcheck disable=SC2183 # printf string has more %s than arguments ($FMT_RAINBOW expands to multiple arguments)
print_success() {
- printf '%s %s__ %s %s %s %s %s__ %s\n' $RAINBOW $RESET
- printf '%s ____ %s/ /_ %s ____ ___ %s__ __ %s ____ %s_____%s/ /_ %s\n' $RAINBOW $RESET
- printf '%s / __ \\%s/ __ \\ %s / __ `__ \\%s/ / / / %s /_ / %s/ ___/%s __ \\ %s\n' $RAINBOW $RESET
- printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s / /_%s(__ )%s / / / %s\n' $RAINBOW $RESET
- printf '%s\\____/%s_/ /_/ %s /_/ /_/ /_/%s\\__, / %s /___/%s____/%s_/ /_/ %s\n' $RAINBOW $RESET
- printf '%s %s %s %s /____/ %s %s %s %s....is now installed!%s\n' $RAINBOW $GREEN $RESET
+ printf '%s %s__ %s %s %s %s %s__ %s\n' $FMT_RAINBOW $FMT_RESET
+ printf '%s ____ %s/ /_ %s ____ ___ %s__ __ %s ____ %s_____%s/ /_ %s\n' $FMT_RAINBOW $FMT_RESET
+ printf '%s / __ \\%s/ __ \\ %s / __ `__ \\%s/ / / / %s /_ / %s/ ___/%s __ \\ %s\n' $FMT_RAINBOW $FMT_RESET
+ printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s / /_%s(__ )%s / / / %s\n' $FMT_RAINBOW $FMT_RESET
+ printf '%s\\____/%s_/ /_/ %s /_/ /_/ /_/%s\\__, / %s /___/%s____/%s_/ /_/ %s\n' $FMT_RAINBOW $FMT_RESET
+ printf '%s %s %s %s /____/ %s %s %s %s....is now installed!%s\n' $FMT_RAINBOW $FMT_GREEN $FMT_RESET
printf '\n'
printf '\n'
- printf "%s %s %s\n" "Before you scream ${BOLD}${YELLOW}Oh My Zsh!${RESET} look over the" \
+ printf "%s %s %s\n" "Before you scream ${FMT_BOLD}${FMT_YELLOW}Oh My Zsh!${FMT_RESET} look over the" \
"$(fmt_code "$(fmt_link ".zshrc" "file://$HOME/.zshrc" --text)")" \
"file to select plugins, themes, and options."
printf '\n'
printf '%s\n' "• Follow us on Twitter: $(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
printf '%s\n' "• Join our Discord community: $(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
printf '%s\n' "• Get stickers, t-shirts, coffee mugs and more: $(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
- printf '%s\n' $RESET
+ printf '%s\n' $FMT_RESET
}
main() {
@@ -377,12 +463,12 @@ main() {
setup_color
if ! command_exists zsh; then
- echo "${YELLOW}Zsh is not installed.${RESET} Please install zsh first."
+ echo "${FMT_YELLOW}Zsh is not installed.${FMT_RESET} Please install zsh first."
exit 1
fi
if [ -d "$ZSH" ]; then
- echo "${YELLOW}The \$ZSH folder already exists ($ZSH).${RESET}"
+ echo "${FMT_YELLOW}The \$ZSH folder already exists ($ZSH).${FMT_RESET}"
if [ "$custom_zsh" = yes ]; then
cat <<EOF
@@ -410,7 +496,7 @@ EOF
print_success
if [ $RUNZSH = no ]; then
- echo "${YELLOW}Run zsh to try it out.${RESET}"
+ echo "${FMT_YELLOW}Run zsh to try it out.${FMT_RESET}"
exit
fi
diff --git a/tools/upgrade.sh b/tools/upgrade.sh
index 994ffe9c9..b6cb10b5a 100755
--- a/tools/upgrade.sh
+++ b/tools/upgrade.sh
@@ -86,6 +86,24 @@ supports_hyperlinks() {
return 1
}
+# Adapted from code and information by Anton Kochkov (@XVilka)
+# Source: https://gist.github.com/XVilka/8346728
+supports_truecolor() {
+ case "$COLORTERM" in
+ truecolor|24bit) return 0 ;;
+ esac
+
+ case "$TERM" in
+ iterm |\
+ tmux-truecolor |\
+ linux-truecolor |\
+ xterm-truecolor |\
+ screen-truecolor) return 0 ;;
+ esac
+
+ return 1
+}
+
fmt_link() {
# $1: text, $2: url, $3: fallback mode
if supports_hyperlinks; then
@@ -107,15 +125,27 @@ setopt typeset_silent
typeset -a RAINBOW
if is_tty; then
- RAINBOW=(
- "$(printf '\033[38;5;196m')"
- "$(printf '\033[38;5;202m')"
- "$(printf '\033[38;5;226m')"
- "$(printf '\033[38;5;082m')"
- "$(printf '\033[38;5;021m')"
- "$(printf '\033[38;5;093m')"
- "$(printf '\033[38;5;163m')"
- )
+ if supports_truecolor; then
+ RAINBOW=(
+ "$(printf '\033[38;2;255;0;0m')"
+ "$(printf '\033[38;2;255;97;0m')"
+ "$(printf '\033[38;2;247;255;0m')"
+ "$(printf '\033[38;2;0;255;30m')"
+ "$(printf '\033[38;2;77;0;255m')"
+ "$(printf '\033[38;2;168;0;255m')"
+ "$(printf '\033[38;2;245;0;172m')"
+ )
+ else
+ RAINBOW=(
+ "$(printf '\033[38;5;196m')"
+ "$(printf '\033[38;5;202m')"
+ "$(printf '\033[38;5;226m')"
+ "$(printf '\033[38;5;082m')"
+ "$(printf '\033[38;5;021m')"
+ "$(printf '\033[38;5;093m')"
+ "$(printf '\033[38;5;163m')"
+ )
+ fi
RED=$(printf '\033[31m')
GREEN=$(printf '\033[32m')
@@ -164,7 +194,7 @@ last_commit=$(git rev-parse "$branch")
# Update Oh My Zsh
printf "${BLUE}%s${RESET}\n" "Updating Oh My Zsh"
-if git pull --rebase --stat $remote $branch; then
+if LANG= git pull --quiet --rebase $remote $branch; then
# Check if it was really updated or not
if [[ "$(git rev-parse HEAD)" = "$last_commit" ]]; then
message="Oh My Zsh is already at the latest version."